/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.3 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Mastermodul
Version :
Date    : 09.07.2008
Author  : Joakim Hammer
Company : NTNU
Comments:


Chip type           : ATmega32L
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

#include <mega128.h>
#include <delay.h>
#include <stdio.h>
#include "dppm.h"


void dppm_transmit_block(unsigned char block){

//   unsigned char led = block;
//   led = led << 4;
//   led = 0xFF^led;
//   PORTB = led;
//   delay_ms(1000);


//--------------------------
//UART transmit
   putchar(block);
//--------------------------

   switch (block) {
    case 0xF0:
    PORTB = 0x0F;
     PORTA = 0x01;
     delay_ms(5*DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(5*DPPM_T_SLOT);
    break;
    case 0x00:
    PORTB = 0x5F;
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(9*DPPM_T_SLOT);

    break;
    case 0x01:
    PORTB = 0xEF;
     delay_ms(1*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(8*DPPM_T_SLOT);

    break;
    case 0x02:
    PORTB = 0xDF;
     delay_ms(2*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(7*DPPM_T_SLOT);

    break;
    case 0x03:
    PORTB = 0xCF;
     delay_ms(3*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(6*DPPM_T_SLOT);
    break;
    case 0x04 :
    PORTB = 0xAF;
     delay_ms(4*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(5*DPPM_T_SLOT);
    break;
    case 0x05 :
    PORTB = 0x9F;
     delay_ms(5*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(4*DPPM_T_SLOT);
    break;
    case 0x06 :
    PORTB = 0x8F;
     delay_ms(6*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(3*DPPM_T_SLOT);
    break;
    case 0x07 :
    PORTB = 0x7F;
     delay_ms(7*DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT) ;
     PORTA = 0x00;
     delay_ms(2*DPPM_T_SLOT);
    break;
    default:
    PORTB = 0x1F;
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x01;
     delay_ms(DPPM_T_SLOT);
     PORTA = 0x00;
     delay_ms(DPPM_T_SLOT);
    break;
    };

//    delay_ms(1000);
    PORTB=0xFF;
}

void dppm_transmit(unsigned char *str){
        unsigned char block;

        while(*str != '\0'){
           dppm_transmit_block(0xF0);


           block = 0xE0 & *str;
           block = block >> 5;
           dppm_transmit_block(block);

           block = 0x1C & *str;
           block = block >> 2;
           dppm_transmit_block(block);

           block = 0x03 & *str;
           block = (block<<1);
           str++;
             if( *str == '\0') break;
           block = block |  ((0x70 & *str)>>7);
           dppm_transmit_block(block);

           block = 0x70 & *str;
           block = block >> 4;
           dppm_transmit_block(block);

           block = 0x0E & *str;
           block = block >> 1;
           dppm_transmit_block(block);

           block = 0x01 & *str;
           block = (block<<2);
           str++;
             if( *str == '\0') break;
           block = block |  ((0xC0 & *str)>>6);
           dppm_transmit_block(block);

           block = 0x38 & *str;
           block = block >> 3;
           dppm_transmit_block(block);

           block = block = 0x07 & *str;
           dppm_transmit_block(block);

           str++;

        }

}