/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.3 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Mastermodul
Version :
Date    : 09.07.2008
Author  : Joakim Hammer
Company : NTNU
Comments:


Chip type           : ATmega32L
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

#include <stdio.h>
#include "main.h"

char decode_fiskepakke(char *dppm_luke, char *fiskepakke){
//shift inn riktig bit-kombinasjon i fiskepakke...
  //teller
  int i = 0;
  int j;
  char block;


  //synk-datablock
  for(j=0;j<5;j++){
          if(dppm_luke[i]!=0xFF)
            return -1;

        i++;
  }
  for(j=0;j<5;j++){
         if(dppm_luke[i]!= 0xAA)
           return -1;
        i++;
  }

  //om vi kommer hit var syncpulsen ok
  while(i<PAKKELENGDE_TIDSLUKER){
    block = 0x00;

    for(j=0;j<8;j++){
      block |= (dppm_luke[i] & 0x01) << j;
      i++;
    }
    i = i + DPPM_DODTID;

      //om vi kommer hit er tidslukene dekodet
  switch (block) {
    case 0x01:
        block = 0x00;
    break;
    case 0x02:
        block = 0x01;
    break;
    case 0x04:
        block = 0x02;
    break;
    case 0x08:
        block = 0x03;
    break;
    case 0x10:
        block = 0x04;
    break;
    case 0x20:
        block = 0x05;
    break;
    case 0x40:
        block = 0x06;
    break;
    case 0x80:
        block = 0x07;
    break;
    case 0x00:
        block = 0xFF;
    break;
    default:
        error("default");
        return -1;
    break;
  }

    putchar(block);

  }



  return 1;
}