#include "ser.h"
#include "serIO.h"


//dataflags
#define NEW_NODE	0x01

#define NODE1		0x0A
#define NODE2		0x0B
#define NODE3		0x0C
#define BROADCAST	0xFF

int wait_for_config(){
	while(!readport(fd,sResult)){}
	if(sResult != '<')
		return -1
	else return 0;
}

int change_addr(char addr)
{
	char sCmd[254]; //message

	set_RTS_high()
	set_RTS_low()

	wait_for_config()
		memset(sCmd, 0, sizeof(sCmd));
		sCmd[0] = 'T';
	writeport(fd, sCmd);
	wait_for_config()
		memset(sCmd, 0, sizeof(sCmd));
		sCmd[0] = addr;
	writeport(fd, sCmd);
	wait_for_config()
		memset(sCmd, 0, sizeof(sCmd));
		sCmd[0] = 'X';
	writeport(fd, sCmd);

	return 0;
}

/*
int main(int argc, char **argv)
{
	change_addr(0x0A);

}
*/


